extends ../../includes/layout

block content
    link(href='/vendor/bootstrap-daterangepicker/daterangepicker.css' rel='stylesheet')

    link(href='/vendor/clockpicker/css/bootstrap-clockpicker.min.css' rel='stylesheet')

    link(href='/vendor/jquery-asColorPicker/css/asColorPicker.min.css' rel='stylesheet')

    link(href='/vendor/bootstrap-material-datetimepicker/css/bootstrap-material-datetimepicker.css' rel='stylesheet')

    link(rel='stylesheet' href='/vendor/pickadate/themes/default.css')
    link(rel='stylesheet' href='/vendor/pickadate/themes/default.date.css')
    link(href='https://fonts.googleapis.com/icon?family=Material+Icons' rel='stylesheet')

    style.
        .btn-file{
            width: 500px !important;
        }

        .list_pictures{
            margin:5px;
        }

    .d-flex.align-items-center.mb-4
        h4.fs-20.font-w600.mb-0.me-auto 
    .row 
        .col-xl-12
            .card
                .card-header
                    h4.card-title #{nav}
                .card-body
                    .row
                        .col-sm-12
                            .basic-form
                                form

                                    input(type="hidden" name="action" id="action", value=action)
                                    input(type="hidden" name="id" id="id", value=id)
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Name
                                        .col-sm-9
                                            input.form-control.solid(type='text' required value="")#name
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Detail
                                        .col-sm-9
                                            input.form-control.solid(type='text' required value="")#detail
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Price Start
                                        .col-sm-9
                                            input.form-control.solid(type='number' required value="10000")#startPrice
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Step
                                        .col-sm-9
                                            input.form-control.solid(type='number' required value="20")#step
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Order No
                                        .col-sm-9
                                            input.form-control.solid(type='number' required value="1")#orderNo
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Type
                                        .col-sm-9
                                            select#type.form-control.solid
                                                option(value="default") Default
                                                option(value="furniture") Furniture
                                                option(value="radio_station") Radio Station 
                                    .mb-3.row
                                        label.col-sm-3.col-form-label Pictures
                                        .col-sm-9
                                            input.form-file-input.form-control.btn-file(type='file' multiple)#pictures
                                            button#change_picture.btn.btn-link.hide(type='button') Chang file
                                            div#list_pictures.hide

                                    .mb-3.row
                                        label.col-sm-3.col-form-label Lot
                                        .col-sm-9
                                            select.form-control.solid#lot
                                                each val,index in lot
                                                    option(value=val._id)=val.name
                                    fieldset.mb-3
                                        .row
                                            label.col-form-label.col-sm-3.pt-0.radio-inline Status
                                            .col-sm-9
                                                .form-check
                                                    input.status(type='radio' name='radio_status' value='wait' checked='' required)
                                                    label.form-check-label
                                                        | Wait
                                                .form-check
                                                    input.status(type='radio' name='radio_status' value='open' required)
                                                    label.form-check-label
                                                        | Open
                                                .form-check
                                                    input.status(type='radio' name='radio_status' value='hide' required)
                                                    label.form-check-label
                                                        | Hide

                                    .mb-3.row
                                        .col-sm-10
                                            button.btn.btn-primary(type='button')#btn_submit #{action}

                                            a.btn.btn-info.l-5(type='button',href=base_url+'admin/product') Cancel

block script
    script(src='/vendor/bootstrap-daterangepicker/daterangepicker.js')
    script(src='/vendor/clockpicker/js/bootstrap-clockpicker.min.js')
    script(src='/vendor/jquery-asColor/jquery-asColor.min.js')
    script(src='/vendor/jquery-asGradient/jquery-asGradient.min.js')
    script(src='/vendor/jquery-asColorPicker/js/jquery-asColorPicker.min.js')
    script(src='/vendor/bootstrap-material-datetimepicker/js/bootstrap-material-datetimepicker.js')
    script(src='/vendor/pickadate/picker.js')
    script(src='/vendor/pickadate/picker.time.js')
    script(src='/vendor/pickadate/picker.date.js')

    link(rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/dropzone/4.3.0/dropzone.css')
    script(type='text/javascript' src='https://cdnjs.cloudflare.com/ajax/libs/dropzone/4.3.0/dropzone.js')


    script.
        console.log('emailxxx',email)

        $(document).ready(function(){
            $('#btnUpload').on('click',function(){
                myDropzone.processQueue();
            });
        });

        var start = Date.now();
        var action = $('#action').val()
        var id = $('#id').val()

        console.log('product id : '+id)
        console.log('action : '+action)
        console.log('start ',formatDate(start));

        $('#date_start').val(formatDate(start));
        $('#date_end').val(formatDate(start));

        if(action == 'edit'){
            laod_data(id)
        }

        function laod_data(id){
            $.ajax({
                url: "#{base_url}admin/product/data",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    id:id
                },
                success: function (data, status, xhr) {
                    if(status=='success' && xhr.status==201 && data.result){
                        console.log(data)
                        const product = data.data
                        $('#name').val(product.name)
                        $('#startPrice').val(product.startPrice)
                        $('#round_countdown').val(product.round_countdown)
                        $('#round_max').val(product.round_max)
                        $('#step').val(product.step)
                        $('#detail').val(product.detail)
                        $('#province').val(product.province)

                        product.custom_time_end = moment(product.date_end).format('HH:mm')
                        product.custom_date_end = moment(product.date_end).format('YYYY/MM/DD')

                        product.custom_time_start = moment(product.date_start).format('HH:mm')
                        product.custom_date_start = moment(product.date_start).format('YYYY/MM/DD')

                        console.log(product)

                        $('#date_start').val(product.custom_date_start)
                        $('#time_start').val(product.custom_time_start)
                        $('#date_end').val(product.custom_date_end)
                        $('#time_end').val(product.custom_time_end)


                        $('#orderNo').val(product.orderNo)

                        if(product.pictures.length==0){
                            $('#pictures').show()
                            $('#list_pictures').hide()
                            $('#change_picture').hide()
                        }else{
                            $('#pictures').hide()
                            $('#list_pictures').show()
                            $('#change_picture').show()

                            $(product.pictures).each(function(key , val){
                                console.log('val : ',val)

                                    $('<img src="/uploads/'+val+'" width="100px" class="list_pictures">').appendTo("#list_pictures");
                            })
                        }



                        //select
                        $("#lot option[value="+product.lot+"]").attr('selected','selected');

                        //radio
                        $("input[name=radio_status][value="+product.status+"]").prop("checked",true);

                        $("input[name=method_start][value="+product.method_start+"]").prop("checked",true);

                        var method_start = $(".method_start:checked").val();

                        if(method_start=='custom'){
                            $('.form_datetime').show();
                        }else{
                            $('.form_datetime').hide();
                        }
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }

                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }
                    console.log(xhr);
                    console.log(status);
                    console.log(error);
                    //redirect_login();
                },
            });
        }

        $('#change_picture').click(function(){

            console.log('change_picture')

        });


        function formatDate(date) {
            var d = new Date(date),
                month = '' + (d.getMonth() + 1),
                day = '' + d.getDate(),
                year = d.getFullYear();

            if (month.length < 2) 
                month = '0' + month;
            if (day.length < 2) 
                day = '0' + day;

            return [year, month, day].join('/');
        }


        $('.clockpicker').clockpicker({
            donetext: 'Done',
        }).find('input').change(function () {
            console.log(this.value);
        });

        $('.datepicker-default').pickadate({
            format: 'yyyy/mm/dd',
            formatSubmit: 'yyyy/mm/dd'
        });

        $('.method_start').change(function(){

            var method_start = $('.method_start:checked').val();

            console.log(method_start);

            if(method_start=='custom'){
                $('.form_datetime').show();
            }else{
                $('.form_datetime').hide();
            }

        });




        function edit_data(data){
            $.ajax({
                url: "#{base_url}admin/product/edit",
                headers: {
                    "Authorization": "Bearer "+access_token
                },
                method: "POST",
                dataType: "json",
                data:data,
                cache: false,
                contentType: false,
                processData: false,
                success: function (data, status, xhr) {
                    if(status=='success' && xhr.status==201 && data.result){
                        swal({
                            title: "Success!",
                            text:  data.message,
                            type: "success",
                            showCancelButton: true,
                            confirmButtonColor: '#DD6B55',
                            confirmButtonText: 'Back to list',
                            cancelButtonText: "Stay thisin page"
                        }).then(function(result) {
                            console.log(result)
                            if(result.value){
                                window.location = "#{base_url}admin/product";
                            }
                        })
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }

                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }
                    console.log(xhr);
                    console.log(status);
                    console.log(error);
                    //redirect_login();
                },
            });
        }


        $('#btn_submit').click(function(){
            var name = $('#name').val();
            var detail = $('#detail').val();
            var status = $(".status:checked").val();
            var type = $('#type').val()
            var startPrice = $('#startPrice').val()
            var step = $('#step').val()
            var lot = $('#lot').val()
            var id = $('#id').val()
            var orderNo = $('#orderNo').val()

            var fileData = new FormData();

            var files = document.getElementById("pictures").files;

            console.log('files L ',files)

            for (var i = 0; i < files.length; i++)
            {
                console.log(files[i])
                fileData.append("pictures", files[i]);
            }

            //- alert(form_data);   
            //- return false;
            fileData.append("user_id", user_id);
            fileData.append("id", id);
            fileData.append("name", name);
            fileData.append("detail", detail);
            fileData.append("status", status);
            fileData.append("type", type);
            fileData.append("startPrice", startPrice);
            fileData.append("step", step);
            fileData.append("lot", lot);
            fileData.append("orderNo", orderNo);
            //fileData.append("pictures", files);


            if(name==''){
                $('#name').focus();
                console.log(1)
            }else if(type==''){
                console.log(5)
                $('#type').focus();
            }else if(startPrice==''){
                console.log(6)
                $('#startPrice').focus();
            }else if(step==''){
                console.log(7)
                $('#step').focus();
            }else if(orderNo==''){
                console.log(7)
                $('#step').focus();
            }else{
                console.log($('#action').val())
                if($('#action').val()=='edit'){
                    swal({
                        title: "Are you sure?",
                        text: action+" data ? ",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: '#DD6B55',
                        confirmButtonText: 'Yes, I am sure!',
                        cancelButtonText: "No, cancel it!"
                    }).then(function(result) {
                        console.log(result)
                        if(result.value){
                            edit_data(fileData)
                        }
                    })
                }else{
                    swal({
                        title: "Are you sure?",
                        text: action+" data ? ",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: '#DD6B55',
                        confirmButtonText: 'Yes, I am sure!',
                        cancelButtonText: "No, cancel it!"
                    }).then(function(result) {
                        console.log(result)
                        if(result.value){
                            add_data(fileData);
                        }
                    })
                }   

            }
        });





        function add_data(data){
            $.ajax({
                url: "#{base_url}admin/product/create",
                headers: {
                    "Authorization": "Bearer "+access_token
                },
                method: "POST",
                dataType: "json",
                data:data,
                cache: false,
                contentType: false,
                processData: false,
                success: function (data, status, xhr) {
                    if(status=='success' && xhr.status==201 && data.result){
                        //swal("Success", data.message, "success");
                        $('#action').val('edit')
                        $('#id').val(data.item._id)
                        $('#btn_submit').text('edit')

                        swal({
                            title: "Success!",
                            text:  data.message,
                            type: "success",
                            showCancelButton: true,
                            confirmButtonColor: '#DD6B55',
                            confirmButtonText: 'Back to list',
                            cancelButtonText: "Stay this page"
                        }).then(function(result) {
                            console.log(result)
                            if(result.value){
                                window.location = "#{base_url}admin/product";
                            }
                        })
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }

                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }
                    console.log(xhr);
                    console.log(status);
                    console.log(error);
                    //redirect_login();
                },
            });
        }
